local demo_1 = {}

local _graph = require 'graph'
local _nerv = require 'nerv'

local graph,nerv,fn1,fn2,mag

function demo_1.load()
  graph = _graph(0,Stage.h/2,8,Stage.w,Stage.h/2,1,1)
  nerv = _nerv():setFunctions(function() fn1 = fn1 + 1 end, function() fn2 = fn2 + 1 end)
  fn1 = 0
  fn2 = 0
  mag = 1
end

function demo_1.update(dt)
  nerv:send(mag)
  nerv:update(dt)
  graph:update( nerv:getPotential() )
end

function demo_1.draw()
  graph:draw()
  love.graphics.print( 'no. of times fn_onStart() has been called = ' .. fn1, 0,0 )
  love.graphics.print( 'no. of times fn_onFinished() has been called = ' .. fn2, 0,32 )
  love.graphics.print( 'magnitude of stimulus sent to nerv cell at each frame = ' .. mag, 0,64 )
  love.graphics.print( '(press UP and DOWN to change the magnitude of stimulus)', 0,96 )
end

function demo_1.keypressed(key)
  if key == 'up' then
    mag = mag + .1
  elseif key == 'down' then
    mag = mag - .1
  end
end

return demo_1