local demo_2 = {}

local nerv = require 'nerv'

local nerv_table

function demo_2.load()
  nerv_table = {}
  for i = 1, math.floor(Stage.w/4+1) do
	table.insert( nerv_table, nerv() )
  end
end

function demo_2.update(dt)
  local x,y = love.mouse.getPosition()
  for i = 1, #nerv_table do
	nerv_table[i]:update(dt)
  
    local distance = math.sqrt( (x-(i-1)*4)^2 + (y-Stage.h/8*6)^2 )
	local _inv = 1/distance
	local magnitude = _inv * 100
	nerv_table[i]:send(magnitude)
  end
end

function demo_2.draw()
  for i = 1, #nerv_table do
    love.graphics.circle( 'fill', (i-1)*4, Stage.h/8*6 - nerv_table[i]:getPotential()*Stage.h/16, 2 )
  end
  love.graphics.print( 'distance-based stimulus', 0,0 )
  love.graphics.print( '(move your mouse)', 0,32 )
end

function love.keypressed(key)

end

return demo_2