local demo_3 = {}

local nerv = require 'nerv'

local nerv_table

function demo_3.load()
  nerv_table = {}
  for i = 1, math.floor(Stage.w/4+1) do
	nerv_table[i] = nerv():sync()
  end
end

function demo_3.update(dt)
  love.window.setTitle( love.timer.getFPS() )

  local x,y = love.mouse.getPosition()
  for i = 1, #nerv_table do
	nerv_table[i]:update(dt)
  
    local distance = math.sqrt( (x-(i-1)*4)^2 + (y-Stage.h/8*6)^2 )
	local _inv = 1/distance
	local magnitude = _inv * 100
	nerv_table[i]:send(magnitude)
  end
end

function demo_3.draw()
  for i = 1, #nerv_table do
    love.graphics.circle( 'fill', (i-1)*4, Stage.h/8*6 - nerv_table[i]:getPotential()*Stage.h/16, 2 )
  end
  love.graphics.print( 'synchronised', 0,0 )
end

function demo_3.keypressed(key)

end

return demo_3



