local demo_5 = {}

local nerv = require 'nerv'

local nerv_table

function demo_5.load()
  nerv_table = {}
  for x = 1, math.floor((Stage.w-160*2)/12+1) do
    nerv_table[x] = {}
    for y = 1, math.floor((Stage.h-160*2)/12+1) do
	  nerv_table[x][y] = nerv():setPotentials(2,_,_):setPeriod(1.2)
	end
  end
  for x = 1, #nerv_table do
    for y = 1, #nerv_table[x] do
	  if y == 1 or y == #nerv_table[x] then
	    --nothing
	  else
	    nerv_table[x][y]:connect(nerv_table[x][y-1])
	    nerv_table[x][y]:connect(nerv_table[x][y+1])
	  end
	  if x == 1 or x == #nerv_table then
	    --nothing
	  else
	    nerv_table[x][y]:connect(nerv_table[x-1][y])
	    nerv_table[x][y]:connect(nerv_table[x+1][y])
	  end
	end
  end
end

function demo_5.update(dt)
  local mx,my = love.mouse.getPosition()
  for x = 1, #nerv_table do
    for y = 1, #nerv_table[x] do
	  nerv_table[x][y]:update(dt)
  
      local distance = math.sqrt( (mx-(160+(x-1)*12))^2 + (my-(160+(y-1)*12))^2 )
	  local _inv = 1/distance
	  local magnitude = _inv * 100
	  nerv_table[x][y]:send(magnitude)
    end
  end
end

function demo_5.draw()
  for x = 1, #nerv_table do
    for y = 1, #nerv_table[x] do
	  local p = nerv_table[x][y]:getPotential()*200
	  local p2 = nerv_table[x][y]:getPotential()*6
	  love.graphics.setColor(math.max(0,255-p/2),math.max(0,255-p/4),math.max(0,255-p/6),math.min(25+p,255))
      love.graphics.circle( 'fill', 160+(x-1)*12, 160+(y-1)*12, 12+p2 )
	end
  end
  love.graphics.setColor(255,255,255,255)
  love.graphics.print( 'connect nerv cells to those around them', 0,0 )
end

function demo_5.keypressed(key)

end

return demo_5




