local graph = {}
graph.__index = graph

function graph.new( x,y, scale, width,height, interval, critical_value )
  --scale is relative length of the y axis
  --y is coord of the bottom left corner
  return setmetatable( {
    x = x or 0,
	y = y or 0,
	width = width or love.window.getWidth(),
	height = height or love.window.getHeight(),
	interval = interval or 1,
	critical_value = critical_value or nil,
	scale = scale or 1,
	pts = {}
	
  }, {__index = graph} )
end

function graph:update(value)
  table.insert( self.pts, self.y-value/self.scale*self.height )
  if #self.pts > self.width/self.interval then table.remove( self.pts, 1 ) end
end

function graph:draw()
  for i = 2, #self.pts do
    local x1, x2 = self.x+(i-2)*self.interval, self.x+(i-1)*self.interval
	local y1, y2 = self.pts[i-1], self.pts[i]
    love.graphics.line( x1, y1, x2, y2 )
  end
  if self.critical_value then
    local y = self.y-self.critical_value/self.scale*self.height
    love.graphics.line( self.x, y, self.x+self.width, y )
  end
end

setmetatable( graph, {__call = function(_,...) return graph.new(...) end } )

return graph